using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace FearTheReaper.Buffs {
	public class SanctifiedBuff : TAPI.ModBuff {
		public override void Effects( Player player, int index ) {
			FTR_Player ftr_player = player.GetSubClass<FTR_Player>();

			int this_type = BuffDef.byName["FearTheReaper:SanctifiedBuff"];
			bool is_same_type = player.buffType[index] == this_type;
			bool is_running = player.buffTime[index] > 0;
			bool player_valid = player.active && !player.dead;

			// Note to devs: Type checking seems to be necessary!
			if( is_same_type && is_running && player_valid ) {
				if( !ftr_player.IsSanctified ) {
					ftr_player.IsSanctified = true;
					netUpdate = true;
				}
			} else {
				if( ftr_player.IsSanctified ) {
					ftr_player.IsSanctified = false;
					netUpdate = true;
				}
			}
		}


		public override void Start( Player player, int index ) {
			FTR_Player ftr_player = player.GetSubClass<FTR_Player>();
			ftr_player.IsSanctified = true;

			netUpdate = true;
		}

		public override void End( Player player, int index ) {
			FTR_Player ftr_player = player.GetSubClass<FTR_Player>();
			ftr_player.IsSanctified = false;

			netUpdate = true;
		}
    }
}
