using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using DrColor = System.Drawing.Color;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

public class DebugLog {
	private static string LogData = "";
	private static int NumberOfAppends = 0;
	private static int NumberOfPrepends = -1;


	public static void Append( string text ) {
		LogData += NumberOfAppends + ": " + text + "\r\n";
		NumberOfAppends++;
	}

	public static void Prepend( string text ) {
		LogData = NumberOfPrepends + ": " + text + "\r\n" + LogData;
		NumberOfPrepends--;
	}

	public static void Dump( string name_footer = "" ) {
		string curr_time = DateTime.Now.ToString( "h mm ss tt" );
		name_footer = String.IsNullOrWhiteSpace( name_footer ) ? "" : " "+name_footer;
		string world_name = String.IsNullOrWhiteSpace( Main.worldName ) ? "menu" : Main.worldName;

		string path_name = @Mods.path + @"\";
		string file_name = curr_time + " " + world_name + name_footer + ".txt";

		string log_data = file_name + "\r\n================================\r\n" + LogData;

		System.IO.File.WriteAllText( path_name + file_name, log_data );

		NumberOfAppends = 0;
		NumberOfPrepends = -1;
		LogData = "";
    }
}
