using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

using FearTheReaper;


namespace FearTheReaper.Items {
	public class FerryTokenAccessoryItem : ModItem {
		private bool EffectOnce = false;


		public override void OnEquip( Player player, TAPI.UIKit.ItemSlot slot ) {
			EffectOnce = false;
		}

		public override void OnUnEquip( Player player, TAPI.UIKit.ItemSlot slot ) {
			FTR_Player ftr_player = player.GetSubClass<FTR_Player>();
			if( ftr_player != null ) { ftr_player.EquippedFerryToken = null; }	// Lazy
		}


		public override void Effects( Player player ) {	// I use Effects() like this because I'm too lazy to discover if OnEquip fires on player game join
			if( EffectOnce ) { return; }

			FTR_Player ftr_player = player.GetSubClass<FTR_Player>();
			if( ftr_player != null ) {
				ftr_player.EquippedFerryToken = this;	// Lazy
				EffectOnce = true;
			}
		}
	}
}